#include<iostream>
#include<vector>
#include<cstdio>

using namespace std;

const int base = 1e4;

void operator+=(vector<int>& a, const vector<int>& b){
    if(a.size() < b.size())
        a.resize(b.size());
    int carry = 0;
    for(int i = 0; i < a.size() || carry; ++i){
        if(i == a.size())
            a.push_back(0);
        int num = a[i] + (i < b.size() ? b[i] : 0) + carry;
        carry = num/base;
        a[i] = num%base;
    }
}

int operator%(const vector<int>& a, int b){
    int carry = 0;
    for(int i = a.size()-1; i >= 0; --i)
        carry = (a[i] + carry*base)%b;
    return carry;
}

void operator*=(vector<int>& a, int b){
    int carry = 0;
    for(int i = 0; i < a.size() || carry; ++i){
        if(i == a.size())
            a.push_back(0);
        int num = a[i]*b + carry;
        carry = num/base;
        a[i] = num%base;
    }
}

vector<int> operator*(vector<int> a, int b){
    a *= b;
    return a;
}

void operator/=(vector<int>& a, int b){
    int carry = 0;
    for(int i = a.size()-1; i >= 0; --i){
        int num = a[i] + carry*base;
        carry = num%b;
        a[i] = num/b;
    }
}

vector<int> operator/(vector<int> a, int b){
    a /= b;
    return a;
}

int gcd(int a, int b){
    while(b){
        int w = a%b;
        a = b;
        b = w;
    }
    return a;
}

int gcd(const vector<int>& a, int b){
    return gcd(b, a%b);
}

vector<int> lcm(const vector<int>& a, int b){
    return a/gcd(a, b)*b;
}

void print(const vector<int>& v){
    if(v.empty()){
        printf("0\n");
        return;
    }
    printf("%d", v.back());
    for(int i = v.size()-2; i >= 0; --i)
        printf("%04d", v[i]);
    printf("\n");
}

int n, a, d;

int main(){
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);

    scanf("%d%d%d", &n, &a, &d);
    vector<int> res_a(1, a), res_d(1, d);

    int i = 1;
    if(d != 0){
        for(; i < n; ++i){
            scanf("%d%d", &a, &d);
            if(d == 0){
                if((a != base || res_a.size() != 2 || res_a[0] != 0 || res_a[1] != 1) && (res_a.size() > 1 || res_a[0] > a || (res_d.size() > 1 && res_a[0] != a) || (res_a[0] != a && (a - res_a[0])%res_d[0]))){
                    printf("0\n");
                    return 0;
                }
                ++i;
                break;
            }
            while(res_a.size() <= 1 && res_a[0] < a)
                res_a += res_d;
            int rem = (res_a%d - a)%d, rem_dif = res_d%d;
            int k;
            for(k = 0; k < d; ++k)
                if((rem + rem_dif*k)%d == 0){
                    res_a += res_d*k;
                    res_d = lcm(res_d, d);
                    break;
                }
            if(k == d){
                printf("0\n");
                return 0;
            }
        }
    }
    if(d == 0){
        int ans_a = a;
        for(; i < n; ++i){
            scanf("%d%d", &a, &d);
            if(d == 0){
                if(a != ans_a){
                    printf("0\n");
                    return 0;
                }
                continue;
            }
            if(a > ans_a || (ans_a - a)%d){
                printf("0\n");
                return 0;
            }
        }
        printf("%d\n", ans_a);
        return 0;
    }
    print(res_a);
}
