/* GCC */
#include <bits/stdc++.h>
using namespace std;
int m, n;
int INF = 100000;
vector<vector<char> > v;
vector<vector<int> > dist;
vector<vector<bool> > used;
vector<vector<pair<int, int> > > prev;
vector<pair<int, int> > step(4);

void bfs(pair<int, int> start)
{
    queue<pair<int, int> > q;
    q.push(start);
    dist[start.first][start.second] = 0;

    while(!q.empty())
    {
        int x = q.front().first;
        int y = q.front().second;
        if(!used[x][y])
        {
            used[x][y] = true;
            for(int i = 0; i < step.size(); i++)
            {
                int x1 = step[i].first + x, y1 = step[i].second + y;
                if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && v[x1][y1] != '#' && !used[x1][y1])
                {
                    q.push(make_pair(x1, y1));
                    dist[x1][y1] = dist[x][y] + 1;
                    prev[x1][y1] = make_pair(x, y);
                }
            }
        }
        q.pop();
    }
}

int main()
{
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>> m >> n;
    v.resize(m, vector<char>(n));
    dist.resize(m, vector<int>(n, INF));
    prev.resize(m, vector<pair<int, int> >(n));
    used.resize(m, vector<bool>(n, false));
    step[0] = make_pair(1, 0);
    step[1] = make_pair(-1, 0);
    step[2] = make_pair(0, 1);
    step[3] = make_pair(0, -1);
    string s;
    getline(cin, s);
    pair<int, int> start;

    for(int i = 0; i < m; i++)
    {
        getline(cin, s);
        for(int j = 0; j < n; j++)
        {
            if(j >= s.size())
            {
                v[i][j] = ' ';
                continue;
            }
            if(s[j] == ' ' || s[j] == '+')
                v[i][j] = s[j];
            else
                v[i][j] = '#';
            if(s[j] == '+')
                start = make_pair(i, j);
        }
    }

    if(start.first == 0 || start.first == m - 1 || start.second == 0 || start.second == n - 1)
    {
        cout<< 0 << "\n";
        return 0;
    }


    bfs(start);
    pair<int, int> min_id;
    int min_znach = INF;

    for(int i = 0; i < m; i++)
    {
        if(dist[i][0] < min_znach)
        {
            min_znach = dist[i][0];
            min_id = make_pair(i, 0);
        }
        if(dist[i][n - 1] < min_znach)
        {
            min_znach = dist[i][n - 1];
            min_id = make_pair(i, n - 1);
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(dist[0][i] < min_znach)
        {
            min_znach = dist[0][i];
            min_id = make_pair(0, i);
        }
        if(dist[m - 1][i] < min_znach)
        {
            min_znach = dist[m - 1][i];
            min_id = make_pair(m - 1, i);
        }
    }

    if(min_znach == INF)
    {
        cout<< -1 << "\n";
        return 0;
    }
    cout<< min_znach << "\n";
    string ans = "";

    while(min_id != start)
    {
        int x = min_id.first, y = min_id.second;
        min_id = prev[x][y];
        int x1 = min_id.first, y1 = min_id.second;
        if(x1 + 1 == x && y == y1)
            ans+= 's';
        if(x1 - 1 == x && y == y1)
            ans+= 'n';
        if(x == x1 && y == y1 + 1)
            ans += 'e';
        if(x == x1 && y == y1 - 1)
            ans += 'w';
    }

    reverse(ans.begin(), ans.end());
    cout<< ans << "\n";

    return 0;
}
